local o=require"luci.controller.radicale2"
local s=require("nixio.fs")
local h=require("luci.util")
local n=Map("radicale2",translate("Radicale 2.x"),
translate("A lightweight CalDAV/CardDAV server"))
local t=n:section(NamedSection,"auth","section",translate("Authentication"))
t.addremove=true
t.anonymous=false
local e=t:option(ListValue,"type",translate("Authentication Type"))
e:value("",translate("Default (htpasswd file from users below)"))
e:value("htpasswd",translate("htpasswd file (manually populated)"))
e:value("none",translate("No authentication"))
e:value("remote_user",translate("REMOTE_USER from web server"))
e:value("http_x_remote_user",translate("X-Remote-User from web server"))
e.default=""
e.rmempty=true
local e=t:option(Value,"htpasswd_filename",translate("Filename"),translate("htpasswd-formatted file filename"))
e:depends("type","htpasswd")
e.rmempty=true
e.placeholder="/etc/radicale2/users"
e.default=""
local a=t:option(ListValue,"htpasswd_encryption",translate("Encryption"),translate("Password encryption method"))
a:depends("type","htpasswd")
a:depends("type","")
a:value("plain",translate("Plaintext"))
a:value("sha1",translate("SHA1"))
a:value("ssha",translate("SSHA"))
a:value("crypt",translate("crypt"))
if o.pymodexists("passlib")then
a:value("md5",translate("md5"))
if o.pymodexists("bcrypt")then
a:value("bcrypt",translate("bcrypt"))
end
end
a.default="plain"
a.rmempty=true
if not o.pymodexists("bcrypt")then
e=t:option(DummyValue,"nobcrypt",translate("Insecure hashes"),translate("Install python3-passlib and python3-bcrypt to enable a secure hash"))
else
e=t:option(DummyValue,"nobcrypt",translate("Insecure hashes"),translate("Select bcrypt above to enable a secure hash"))
e:depends("htpasswd_encrypt","")
e:depends("htpasswd_encrypt","plain")
e:depends("htpasswd_encrypt","sha1")
e:depends("htpasswd_encrypt","ssha")
e:depends("htpasswd_encrypt","crypt")
e:depends("htpasswd_encrypt","md5")
end
e=t:option(Value,"delay",translate("Retry Delay"),translate("Required time between a failed authentication attempt and trying again"))
e.rmempty=true
e.default=1
e.datatype="uinteger"
e:depends("type","")
e:depends("type","htpasswd")
e:depends("type","remote_user")
e:depends("type","http_x_remote_user")
t=n:section(TypedSection,"user",translate("User"),translate("Users and Passwords"))
t.addremove=true
t.anonymous=true
e=t:option(Value,"name",translate("Username"))
e.rmempty=true
e.placeholder="johndoe"
if o.pymodexists("passlib")then
local e=t:option(Value,"plain_pass",translate("Plaintext Password"))
e.placeholder="Example password"
e.password=true
local o=t:option(Value,"plain_pass_confirm",translate("Confirm Plaintext Password"))
o.placeholder="Example password"
o.password=true
e.cfgvalue=function(t,a)
return t:formvalue(a)
end
e.write=function(e,e)
return true
end
o.cfgvalue=e.cfgvalue
o.write=e.write
e.validate=function(t,a,e)
if t:cfgvalue(e)~=o:cfgvalue(e)then
return nil,translate("Password and confirmation do not match")
end
return AbstractValue.validate(t,a,e)
end
o.validate=function(a,o,t)
if a:cfgvalue(t)~=e:cfgvalue(t)then
return nil,translate("Password and confirmation do not match")
end
return AbstractValue.validate(a,o,t)
end
local i=t:option(Value,"password",translate("Encrypted Password"),translate("If 'Plaintext Password' filled and matches 'Confirm Plaintext Password' then this field becomes of hash of that password, otherwise this field remains the existing hash (you can also put your own hash value for the type of hash listed above)."))
i.password=true
i.rmempty=false
function encpass(t,n)
local t=e:cfgvalue(n)
local e=o:cfgvalue(n)
local o,n
if not t or not e or t==""or e==""or t~=e then
return nil
end
local e=a:formvalue("auth")
if not e then
e=a:cfgvalue("auth")
end
if not e or e==""or e=="plain"then
return t
end
o,n=h.ubus("rad2-enc","encrypt",{type=e,plainpass=t})
if not o then
return nil
end
return o and o.encrypted_password
end
i.cfgvalue=function(a,t)
if not e:formvalue(t)then
return Value.cfgvalue(a,t)
else
return Value.formvalue(a,t)
end
end
i.formvalue=function(a,t)
if not e:formvalue(t)then
return Value.formvalue(a,t)
else
return encpass(a,t)or Value.formvalue(a,t)
end
end
else
local e=t:option(Value,"password",translate("Encrypted Password"),translate("Generate this field using a generator for Apache htpasswd-style authentication files (for the hash format you have chosen above), or install python3-passlib to enable the ability to create the hash by entering the plaintext in a field that will appear on this page if python3-passlib is installed."))
e.password=true
e.rmempty=false
end
local t=n:section(NamedSection,"section","rights",translate("Rights"),translate("User-based ACL Settings"))
t.addremove=true
t.anonymous=false
e=t:option(ListValue,"type",translate("Rights Type"))
e:value("",translate("Default (owner only)"))
e:value("owner_only",translate("RO: None, RW: Owner"))
e:value("authenticated",translate("RO: None, RW: Authenticated Users"))
e:value("owner_write",translate("RO: Authenticated Users, RW: Owner"))
e:value("from_file",translate("Based on settings in 'Rights File'"))
e:value("none",translate("RO: All, RW: All"))
e.default=""
e.rmempty=true
rights_file=t:option(FileUpload,"file",translate("Rights File"))
rights_file.rmempty=true
rights_file:depends("type","from_file")
e=t:option(Button,"remove_conf",
translate("Remove configuration for rights file"),
translate("This permanently deletes the rights file and configuration to use same."))
e.inputstyle="remove"
e:depends("type","from_file")
function e.write(a,t)
if cert_file:cfgvalue(t)and s.access(e:cfgvalue(t))then s.unlink(rights_file:cfgvalue(t))end
a.map:del(t,"file")
a.map:del(t,"rights_file")
luci.http.redirect(luci.dispatcher.build_url("admin","services","radicale2","auth"))
end
return n
