local i=require("nixio.fs")
local h=require"luci.controller.radicale2"
local e=require("luci.http")
local a=Map("radicale2",translate("Radicale 2.x"),
translate("A lightweight CalDAV/CardDAV server"))
s=a:section(SimpleSection,translate("Radicale v2 Web UI"))
s.addremove=false
s.anonymous=true
o=s:option(DummyValue,"radicale2_webui_go",translate("Go to Radicale v2 Web UI"))
o.template="cbi/raduigo"
o.section="cbi-radicale2_webui"
local e=a:section(NamedSection,"server","section",translate("Server Settings"))
e.addremove=true
e.anonymous=false
o.section="cbi-radicale2_web_ui"
local n=nil
local t=nil
local t=nil
local s=nil
e:tab("general",translate("General Settings"))
e:tab("advanced",translate("Advanced Settings"))
n=e:taboption("general",DynamicList,"host",translate("HTTP(S) Listeners (address:port)"))
n.datatype="list(ipaddrport(1))"
n.placeholder="127.0.0.1:5232"
o=e:taboption("advanced",Value,"max_connection",translate("Max Connections"),translate("Maximum number of simultaneous connections"))
o.rmempty=true
o.placeholder=20
o.datatype="uinteger"
o=e:taboption("advanced",Value,"max_content_length",translate("Max Content Length"),translate("Maximum size of request body (bytes)"))
o.rmempty=true
o.datatype="uinteger"
o.placeholder=100000000
o=e:taboption("advanced",Value,"timeout",translate("Timeout"),translate("Socket timeout (seconds)"))
o.rmempty=true
o.placeholder=30
o.datatype="uinteger"
sslon=e:taboption("general",Flag,"ssl",translate("SSL"),translate("Enable SSL connections"))
sslon.rmempty=true
sslon.default=o.disabled
sslon.formvalue=function(e,t)
if not h.pymodexists('ssl')then
return false
end
return Flag.formvalue(e,t)
end
cert_file=e:taboption("general",FileUpload,"certificate",translate("Certificate"))
cert_file.rmempty=true
cert_file:depends("ssl",true)
t=e:taboption("general",FileUpload,"key",translate("Private Key"))
t.rmempty=true
t:depends("ssl",true)
ca_file=e:taboption("general",FileUpload,"certificate_authority",translate("Client Certificate Authority"),translate("For verifying client certificates"))
ca_file.rmempty=true
ca_file:depends("ssl",true)
o=e:taboption("advanced",Value,"ciphers",translate("Allowed Ciphers"),translate("See python3-openssl documentation for available ciphers"))
o.rmempty=true
o:depends("ssl",true)
o=e:taboption("advanced",Value,"protocol",translate("Use Protocol"),translate("See python3-openssl documentation for available protocols"))
o.rmempty=true
o:depends("ssl",true)
o.placeholder="PROTOCOL_TLSv1_2"
o=e:taboption("general",Button,"remove_conf",
translate("Remove configuration for certificate, key, and CA"),
translate("This permanently deletes the cert, key, and configuration to use same."))
o.inputstyle="remove"
o:depends("ssl",true)
function o.write(a,e)
if cert_file:cfgvalue(e)and i.access(cert_file:cfgvalue(e))then i.unlink(cert_file:cfgvalue(e))end
if t:cfgvalue(e)and i.access(t:cfgvalue(e))then i.unlink(t:cfgvalue(e))end
if ca_file:cfgvalue(e)and i.access(t:cfgvalue(e))then i.unlink(ca_file:cfgvalue(e))end
a.map:del(e,"certificate")
a.map:del(e,"key")
a.map:del(e,"certificate_authority")
a.map:del(e,"protocol")
a.map:del(e,"ciphers")
luci.http.redirect(luci.dispatcher.build_url("admin","services","radicale2","server"))
end
if not h.pymodexists('ssl')then
o=e:taboption("general",DummyValue,"sslnotpreset",translate("SSL not available"),translate("Install package python3-openssl to support SSL connections"))
end
o=e:taboption("advanced",Flag,"dns_lookup",translate("DNS Lookup"),translate("Lookup reverse DNS for clients for logging"))
o.rmempty=true
o.default=o.enabled
o=e:taboption("advanced",Value,"realm",translate("Realm"),translate("HTTP(S) Basic Authentication Realm"))
o.rmempty=true
o.placeholder="Radicale - Password Required"
local e=a:section(NamedSection,"web","section",translate("Web UI"))
e.addremove=true
e.anonymous=false
o=e:option(ListValue,"type",translate("Web UI Type"))
o:value("","Default (Built-in)")
o:value("internal","Built-in")
o:value("none","None")
o.default=""
o.rmempty=true
local e=a:section(NamedSection,"headers","section",translate("Headers"),translate("HTTP(S) Headers"))
e.addremove=true
e.anonymous=false
o=e:option(Value,"cors",translate("CORS"),translate("Header: X-Access-Control-Allow-Origin"))
o.rmempty=true
o.placeholder="*"
local e=a:section(NamedSection,"encoding","section",translate("Document Encoding"))
e.addremove=true
e.anonymous=false
o=e:option(Value,"request",translate("Request"),translate("Encoding for responding to requests/events"))
o.rmempty=true
o.placeholder="utf-8"
o=e:option(Value,"stock",translate("Storage"),translate("Encoding for storing local collections"))
o.rmempty=true
o.placeholder="utf-8"
return a
